DESTINATION_HEADER

uniform sampler2D s_mask;
uniform float u_opacity;
uniform float u_coefficient[5];
uniform vec2 u_offset[5];
varying vec2 v_mask_uv;

void main()
{
	vec4 v0 = u_coefficient[0] * texture2D(s_composite, v_dst_uv + u_offset[0]);
	vec4 v1 = u_coefficient[1] * texture2D(s_composite, v_dst_uv + u_offset[1]);
	vec4 v2 = u_coefficient[2] * texture2D(s_composite, v_dst_uv + u_offset[2]);
	vec4 v3 = u_coefficient[3] * texture2D(s_composite, v_dst_uv + u_offset[3]);
	vec4 v4 = u_coefficient[4] * texture2D(s_composite, v_dst_uv + u_offset[4]);
	vec4 value = v0 + v1 + v2 + v3 + v4;

	float mask = texture2D(s_mask, v_mask_uv).a;
	float factor = u_opacity * mask;

	vec4 dst = texture2D(s_composite, v_dst_uv);	
	gl_FragColor = mix(dst, value, factor);
}
