DESTINATION_HEADER

uniform sampler2D s_mask;
uniform sampler2D s_curve_r;
uniform sampler2D s_curve_g;
uniform sampler2D s_curve_b;
uniform mat3 u_m0;
uniform mat3 u_m1;
uniform float u_opacity;
varying vec2 v_mask_uv;

void main()
{
	vec4 dst = DESTINATION_FETCH;
	
	float r = texture2D(s_curve_r, vec2(dst.r, 0.5)).a;
	float g = texture2D(s_curve_g, vec2(dst.g, 0.5)).a;
	float b = texture2D(s_curve_b, vec2(dst.b, 0.5)).a;
	vec4 value = vec4(r, g, b, dst.a);

	float mask = texture2D(s_mask, v_mask_uv).a;
	float factor = u_opacity * mask;

	gl_FragColor = mix(dst, value, factor);
}