DESTINATION_HEADER

uniform sampler2D s_mask;
uniform sampler2D s_curve_r;
uniform sampler2D s_curve_g;
uniform sampler2D s_curve_b;
uniform float u_opacity;
varying vec2 v_mask_uv;

void main()
{
	vec4 dst = DESTINATION_FETCH;
	float luma = dst.r * 0.2126729 + dst.g * 0.7151522 + dst.b * 0.072175;
	vec4 value;

	value.r = texture2D(s_curve_r, vec2(luma, 0.5)).a;
	value.g = texture2D(s_curve_g, vec2(luma, 0.5)).a;
	value.b = texture2D(s_curve_b, vec2(luma, 0.5)).a;
	value.a = dst.a;

	float mask = texture2D(s_mask, v_mask_uv).a;
    float factor = u_opacity * mask;

	gl_FragColor = mix(dst, value, factor);
}
