DESTINATION_HEADER

uniform sampler2D s_mask;
uniform sampler2D s_curve_r;
uniform sampler2D s_curve_g;
uniform sampler2D s_curve_b;
uniform mat3 u_m0;
uniform mat3 u_m1;
uniform float u_opacity;
varying vec2 v_mask_uv;

void main()
{
	vec4 dst = DESTINATION_FETCH;
	
	vec3 yiq = u_m0 * dst.rgb;
	yiq.yz += 0.5;				// [-0.5, 0.5] to [0, 1]
	yiq.x = texture2D(s_curve_r, vec2(yiq.x, 0.5)).a;
	yiq.y = texture2D(s_curve_g, vec2(yiq.y, 0.5)).a;
	yiq.z = texture2D(s_curve_b, vec2(yiq.z, 0.5)).a;
	yiq.yz -= 0.5;
	vec4 value = dst;			// get alpha
	value.rgb = u_m1 * yiq;

	float mask = texture2D(s_mask, v_mask_uv).a;
	float factor = u_opacity * mask;

	gl_FragColor = mix(dst, value, factor);
}
