DESTINATION_HEADER

uniform sampler2D s_mask;
uniform float u_opacity;
uniform vec3 u_vec3;
uniform mat3 u_m0;
uniform mat3 u_m1;
varying vec2 v_mask_uv;

void main()
{
	vec4 dst = DESTINATION_FETCH;

	vec3 yiq = u_m0 * dst.rgb;
	yiq += u_vec3;
	vec3 rgb = u_m1 * yiq;
	vec4 value = vec4(rgb.r, rgb.g, rgb.b, dst.a);

	float mask = texture2D(s_mask, v_mask_uv).a;
	float factor = u_opacity * mask;

	gl_FragColor = mix(dst, value, factor);
}