DESTINATION_HEADER

uniform sampler2D s_mask;
varying vec2 v_mask_uv;

uniform float u_input_min;
uniform float u_input_max;
uniform float u_input_gamma;
uniform float u_output_min;
uniform float u_output_max;

uniform float u_opacity;

void main()
{
    vec4 dst = DESTINATION_FETCH;
    vec3 color = dst.rgb;

    color = min(max(color - vec3(u_input_min), vec3(0.0)) / (u_input_max - u_input_min), vec3(1.0));

    color = pow(color, vec3(1.0 / u_input_gamma));
    color = mix(vec3(u_output_min), vec3(u_output_max), color);

    vec4 value = vec4(color.r, color.g, color.b, dst.a);

    float mask = texture2D(s_mask, v_mask_uv).a;
    float factor = u_opacity * mask;
    
    gl_FragColor = mix(dst, value, factor);
}

