DESTINATION_HEADER

uniform sampler2D s_mask;
varying vec2 v_mask_uv;

uniform sampler3D s_lut;
uniform vec3 u_lut_size;

uniform float u_opacity;

void main()
{
    vec4 dst = DESTINATION_FETCH;

    vec3 scale = (u_lut_size - 1.0) / u_lut_size;
    vec3 offset = 1.0 / (2.0 * u_lut_size);
    vec3 pos_lut = scale * dst.rgb + offset;

    vec3 rgb = texture3D(s_lut, pos_lut).rgb;

    vec4 value = vec4(rgb.r, rgb.g, rgb.b, dst.a);

    float mask = texture2D(s_mask, v_mask_uv).a;
    float factor = u_opacity * mask;
    
    gl_FragColor = mix(dst, value, factor);
}

