DESTINATION_HEADER

uniform sampler2D s_mask;
varying vec2 v_mask_uv;

// x*y*z -> x*(y*z)
uniform sampler2D s_lut;
uniform vec3 u_lut_size;

uniform float u_opacity;

void main()
{
    vec4 dst = DESTINATION_FETCH;
    
    vec3 scale = (u_lut_size - 1.0) / u_lut_size;
    vec3 offset = 1.0 / (2.0 * u_lut_size);
    vec3 cood = scale * dst.rgb + offset;

    float zslice = cood.b * (u_lut_size.z - 1.0);
    float zslice1 = floor(zslice);
    float zslice2 = ceil(zslice);
    float zloc1 = zslice1 / u_lut_size.z;
    float zloc2 = zslice2 / u_lut_size.z;

    vec4 rgb1 = texture2D(s_lut, vec2(cood.r, zloc1 + cood.g / u_lut_size.z));
    vec4 rgb2 = texture2D(s_lut, vec2(cood.r, zloc2 + cood.g / u_lut_size.z));

    float ratio = zslice - zslice1;
    vec4 value = vec4(mix(rgb1, rgb2, ratio).rgb, dst.a);

    float mask = texture2D(s_mask, v_mask_uv).a;
    float factor = u_opacity * mask;
    
    gl_FragColor = mix(dst, value, factor);
}

