DESTINATION_HEADER

uniform sampler2D s_mask;
uniform float u_opacity;
uniform vec3 u_vec3;
varying vec2 v_mask_uv;

void main()
{
	vec4 dst = DESTINATION_FETCH;

	vec3 rgb = dst.rgb * u_vec3;
	vec4 value = vec4(rgb.r, rgb.g, rgb.b, dst.a);

	float mask = texture2D(s_mask, v_mask_uv).a;
	float factor = u_opacity * mask;

	gl_FragColor = mix(dst, value, factor);
}
