DESTINATION_HEADER

uniform sampler2D s_mask;
uniform float u_opacity;
uniform float u_s;
uniform vec3 u_color;
varying vec2 v_mask_uv;

void main()
{
#if 0

	mat3 m = mat3		// RGB to YIQ
	(
		vec3(0.299, 0.595716, 0.211456),
		vec3(0.587, -0.274453, -0.522591),
		vec3(0.114, -0.321263, 0.311135)
	);
	mat3 m1 = mat3		// YIQ to RGB
	(
		 vec3(1.0, 1.0, 1.0),
		 vec3(0.9563, -0.2721, -1.1070),
		 vec3(0.6210, -0.6474, 1.7046)
	);

#endif

	vec4 dst = DESTINATION_FETCH;

#if 0

	vec3 yiq = m * dst.rgb;
	yiq.yz *= u_s;		// scale chromacity
	vec3 rgb = m1 * yiq;

#endif

#if 1

    vec3 grey = vec3( 1., 1., 1. ) * dot( u_color, dst.rgb );
    vec3 diff = dst.rgb - grey;
    vec3 rgb = grey + diff * u_s;

#endif

    vec4 value = vec4(rgb.r, rgb.g, rgb.b, dst.a);

	float mask = texture2D(s_mask, v_mask_uv).a;
	float factor = u_opacity * mask;

	gl_FragColor = mix(dst, value, factor);
}		