DESTINATION_HEADER

uniform sampler2D s_mask;
uniform float u_opacity;
uniform float u_s;
uniform float u_amount;
varying vec2 v_mask_uv;

void main()
{
	mat3 m = mat3		// RGB to YIQ
	(
		vec3(0.299, 0.595716, 0.211456),
		vec3(0.587, -0.274453, -0.522591),
		vec3(0.114, -0.321263, 0.311135)
	);
	mat3 m1 = mat3		// YIQ to RGB
	(
		 vec3(1.0, 1.0, 1.0),
		 vec3(0.9563, -0.2721, -1.1070),
		 vec3(0.6210, -0.6474, 1.7046)
	);

	vec4 dst = DESTINATION_FETCH;

	vec3 yiq = m * dst.rgb;

    // I dunno
    float i = (0.25 - yiq.y) * 4.0/3.0;
    float p = length(vec2(i * i, yiq.z));
	p = clamp(p * 6.0, 0.0, 1.0);
	p = mix(1.0, u_s, p);

    // compute vivid scaling
    float r = length(yiq.yz);		// calculate chroma distance to origin
	float f = 0.54 - r;				// calculate chroma distance to limit
    if (u_s > 1.0 && f > 0.0) {
		p = mix(1.0, 1.0 + f * 5.6, p - 1.0);
	}

    // blend vivid with saturation based on skin protection param
    p = mix( u_s, p, u_amount );

    yiq.yz *= p;

    vec3 rgb = m1 * yiq;
	vec4 value = vec4(rgb.r, rgb.g, rgb.b, dst.a);

	float mask = texture2D(s_mask, v_mask_uv).a;
	float factor = u_opacity * mask;

	gl_FragColor = mix(dst, value, factor);
}