#version 300 es
precision highp float;

#define T_PING_PONG

#ifdef T_PING_PONG

#define DESTINATION_HEADER uniform sampler2D s_composite; out highp vec4 v_OutputColor;
#define DESTINATION_FETCH  texture(s_composite, v_UVCoord)

#else

#define DESTINATION_HEADER inout highp vec4 v_OutputColor;
#define DESTINATION_FETCH  v_OutputColor

#endif

in vec2 v_UVCoord;
DESTINATION_HEADER

uniform sampler2D s_texture;

uniform sampler2D s_texture_1;
uniform sampler2D s_texture_2;

void main()
{
	highp vec3 WEIGHTS = vec3(0.2126729, 0.7151522, 0.072175);

	highp vec3 rst = texture(s_texture,   v_UVCoord).rgb;
	highp vec3 dst = DESTINATION_FETCH.rgb;//below rendering

	highp float thisValue = dot(rst, WEIGHTS);
	highp float belowValue = dot(dst, WEIGHTS);

	highp float thisLookup  = texture(s_texture_1, vec2(thisValue,  0.5)).a;
	highp float belowLookup = texture(s_texture_2, vec2(belowValue, 0.5)).a;


	highp float factor = thisLookup * belowLookup;

	v_OutputColor.rgb = mix(dst, rst, factor);
	v_OutputColor.a = 1.0;
}
