DESTINATION_HEADER

uniform sampler2D s_texture;
uniform sampler2D s_mask;
uniform mediump float u_opacity;
varying highp vec2 v_tex_uv;
varying highp vec2 v_mask_uv;

void main()
{
    mediump vec4 dst = DESTINATION_FETCH;
    mediump vec4 src = texture2D(s_texture, v_tex_uv);
    mediump float mask = texture2D(s_mask, v_mask_uv).a;
    
    mediump vec4 value;
    
    src.rgb *= src.a;   // pre-multiply source to put it in the same space as pre-multiplied dest

    mediump float esa = u_opacity * src.a;      // effective source alpha
    mediump float m = (1.0 - mask) * 2.0;

    value.rgb = mix(src.rgb, dst.rgb, m);		// interpolate (smooth) or extrapolate (sharpen)
    value.rgb = mix(dst.rgb, value.rgb, esa * dst.a);	// alpha blend mixed result

    value.a = dst.a;                            // smoothing and sharpening do not change existing dest alpha

    gl_FragColor = value;

}
