uniform sampler2D s_texture_0;
uniform sampler2D s_texture_1;
uniform sampler2D s_texture_2;
uniform lowp float u_opacity;
varying highp vec2 v_tex_uv;

void main()
{
	highp vec2 uv;
	uv.y = v_tex_uv.y;
	lowp vec4 color;
	if (v_tex_uv.x < 1.0/3.0)
	{
		uv.x = v_tex_uv.x * 3.0;
		color = texture2D(s_texture_0, uv);
	}
	else if (v_tex_uv.x < 2.0/3.0)
	{
		uv.x = v_tex_uv.x * 3.0 - 1.0;
		color = texture2D(s_texture_1, uv);
	}
	else
	{
		uv.x = v_tex_uv.x * 3.0 - 2.0;
		color = texture2D(s_texture_2, uv);
	}
	color.a *= u_opacity;
	gl_FragColor = color;
}
