
DESTINATION_HEADER
uniform sampler2D s_texture;
uniform samplerExternalOES s_mask;
uniform lowp float u_opacity;
varying highp vec2 v_tex_uv;
varying highp vec2 v_mask_uv;

void main()
{
	lowp vec4 color = texture2D(s_texture, v_tex_uv);
	lowp float mask = texture2D(s_mask, v_mask_uv).r;
	lowp vec4 dst = DESTINATION_FETCH;

	lowp float esa = color.a * u_opacity * mask;

	lowp vec4 value;

	value.a = SCREEN_ALPHA(esa, dst.a);
	lowp float fa = FRACTIONAL_SOURCE_ALPHA(esa, value.a);

	value.rgb = mix(dst.rgb, color.rgb, fa);

	gl_FragColor = value;
	//gl_FragColor.r = 1.0;
}