DESTINATION_HEADER

uniform sampler2D s_mask;
varying highp vec2 v_tex_uv;

void main()
{
    vec4 dst = DESTINATION_FETCH;

	mediump float x = mod(gl_FragCoord.x, 40.0);
	mediump float y = mod(gl_FragCoord.y, 40.0);

    const float gray = 234.0 / 255.0; // same as Mix

    vec4 color;
    
	if (x >= 20.0 ^^ y >= 20.0)		// logical exclusive or, grid same as Mix
		color = vec4(1.0, 1.0, 1.0, 1.0);       // opaque white
	else
        color = vec4(gray, gray, gray, 1.0);    // opaque light gray
    
    vec4 value;
    
    if (dst.a == 0.0) {
        value = color;  // checkerboard is opaque and is the final pixel
    } else if (dst.a == 1.0) {
        value = dst;    // checkerboard doesn't draw for this pixel
    } else {
        dst.rgb /= dst.a;   // divide alpha (remove pre-multiply)
        value.rgb = mix (dst.rgb, color.rgb, 1.0 - dst.a);  // linear blend
        value.a = 1.0;
    }
    
    gl_FragColor = value;
}