#version 300 es

precision highp float;

uniform highp mat4 u_transform;
in highp vec4  a_vertex;
in highp vec2  a_tex_uv;

out vec2 v_UVCoord;
out vec2 v_UVCoord_Dst;

void main()
{
	// render the scene verteces
	v_UVCoord   = a_tex_uv;
	vec4 pos    = u_transform * vec4(a_vertex.xy, 0.0, 1.0);
	gl_Position = pos;

	// screen vertices maps to [0,1] range of the texture uv for rendered image per pixel copy
	v_UVCoord_Dst.x = (pos.x / pos.w + 1.0) * 0.5;		// convert from device space [-1, 1] to texture
	v_UVCoord_Dst.y = (pos.y / pos.w + 1.0) * 0.5;		// space [0, 1] of the composite destination
}
