#ifndef DESTINATION_HEADER
#define DESTINATION_HEADER // Warning suppression
#endif
DESTINATION_HEADER

#define PI 3.14159265359

uniform samplerExternalOES s_source;
uniform sampler2D s_mask;
uniform mediump float u_opacity;
varying highp vec2 v_src_uv;
varying highp vec2 v_mask_uv;


float noise(vec2 p)
{
	return fract(9970. * sin(23.*PI*(p.x*6.1+p.y*2.3)));
}


void main()
{
	mediump vec4 src = texture2D(s_source, v_src_uv);
	mediump vec4 dst = DESTINATION_FETCH;

	mediump float a = texture2D(s_mask, v_mask_uv).a * u_opacity * src.a;
	src.a = 1.0;

	float n = noise(v_src_uv);

	gl_FragColor = (n < a) ? src : dst;
}