
DESTINATION_HEADER

uniform samplerExternalOES s_source;
uniform sampler2D s_mask;
uniform mediump float u_opacity;
varying highp vec2 v_src_uv;
varying highp vec2 v_mask_uv;

mediump float blend(mediump float dst, mediump float src)
{
	return 0.5 - 2.0 * (dst - 0.5) * (src - 0.5);
}

void main()
{
	mediump vec4 src = texture2D(s_source, v_src_uv);
	mediump vec4 dst = DESTINATION_FETCH;

	mediump vec4 value;
	value.r = blend(dst.r, src.r);
	value.g = blend(dst.g, src.g);
	value.b = blend(dst.b, src.b);

    value.rgb = mix(src.rgb, value.rgb, dst.a);

	mediump float mask = texture2D(s_mask, v_mask_uv).a;
	mediump float esa = u_opacity * src.a * mask;

	value.a = SCREEN_ALPHA(esa, dst.a);
	mediump float fa = FRACTIONAL_SOURCE_ALPHA(esa, value.a);
	value.rgb = mix(dst.rgb, value.rgb, fa);

	gl_FragColor = value;
}
