DESTINATION_HEADER

uniform sampler2D s_source;
uniform sampler2D s_mask;
uniform mediump float u_opacity;
varying highp vec2 v_src_uv;
varying highp vec2 v_mask_uv;


mediump float blend(mediump float dst, mediump float src)
{
	if (dst >= 0.5)
		return 1.0 - (1.0 - src) * (1.0 - dst) * 2.0;		// 1.0f -  (1.0f - src) * ((1.0f - dst) * 2.0f);
	else
		return src * dst * 2.0;			// (src * dst * 2.0f)
}

void main()
{
	mediump vec4 src = texture2D(s_source, v_src_uv);
	mediump vec4 dst = DESTINATION_FETCH;

	mediump vec4 value;
	value.r = blend(dst.r, src.r);
	value.g = blend(dst.g, src.g);
	value.b = blend(dst.b, src.b);

    value.rgb = mix(src.rgb, value.rgb, dst.a);

	mediump float mask = texture2D(s_mask, v_mask_uv).a;
	mediump float esa = u_opacity * src.a * mask;
	value.a = SCREEN_ALPHA(esa, dst.a);
	value.rgb = mix(dst.rgb, value.rgb, esa);

	gl_FragColor = value;
}
