DESTINATION_HEADER

uniform sampler2D s_source;
uniform sampler2D s_mask;
uniform mediump float u_opacity;
varying highp vec2 v_src_uv;
varying highp vec2 v_mask_uv;


mediump float blend(mediump float dst, mediump float src)
{
	return (dst + src) - (dst * src);			// (a + b) - (a * b)
}

void main()
{
	mediump vec4 src = texture2D(s_source, v_src_uv);
	mediump vec4 dst = DESTINATION_FETCH;

	mediump vec4 value;
	value.r = blend(dst.r, src.r);
	value.g = blend(dst.g, src.g);
	value.b = blend(dst.b, src.b);

	mediump float mask = texture2D(s_mask, v_mask_uv).a;
	mediump float esa = u_opacity * src.a * mask;
	value.a = SCREEN_ALPHA(esa, dst.a);
	value.rgb = mix(dst.rgb, value.rgb, esa);

	gl_FragColor = value;
}

