struct FragmentData_processor
{
    highp float opacity;        ///< opacity

    highp float timeElapsed;    ///< reference time (in seconds)

    highp vec2 dimension;       ///< pixel dimension of target

    highp float param0;         ///< scale X

    highp float param1;         ///< scale Y

    highp float param2;         ///< offset
};

uniform sampler2D s_texture;
uniform sampler2D s_texture_1;
varying highp vec2 v_tex_uv;
varying highp vec2 v_other;
uniform FragmentData_processor u;

void main()
{
    vec4 displacePixel = texture2D(s_texture_1, v_other);

    highp float scaleX = u.param0;
    highp float scaleY = u.param1 * u.dimension.x / u.dimension.y;
    highp float offset = u.param2;

    highp float x = (displacePixel.r - offset) * scaleX;
    highp float y = (displacePixel.g - offset) * scaleY;

    highp vec2 texCoord = v_tex_uv + vec2(x, y);

    gl_FragColor = texture2D(s_texture, texCoord);
}
