uniform sampler2D s_texture;
uniform vec2 u_center;
uniform float u_amount;
varying vec2 v_tex_uv;

void main()
{
	vec2 delta = v_tex_uv - u_center;
	float radius = length(delta);
	float theta = atan(delta.y, delta.x);

	radius = radius * radius * u_amount;		// fish eye - default 1/sqrt(2)

	delta.x = radius * cos(theta);
	delta.y = radius * sin(theta);
	gl_FragColor = texture2D(s_texture, u_center + delta);
}
