uniform sampler2D s_texture;
uniform vec2 u_center;
uniform float u_amount;
varying vec2 v_tex_uv;

void main()
{
	vec2 delta = v_tex_uv - u_center;
	vec4 accum = vec4(0.0, 0.0, 0.0, 0.0);
	for (int i = 0; i < 16; ++i)
	{
		float scale = 1.0 + u_amount * (float(i) / 16.0);
		vec2 uv = delta * scale;
		uv += u_center;
		accum += texture2D(s_texture, uv);
	}
	gl_FragColor = accum / 16.0;
}
