uniform sampler2D s_texture;
uniform vec2 u_center;
uniform float u_r0;
varying vec2 v_tex_uv;

void main()
{
	vec4 color0 = texture2D(s_texture, v_tex_uv);

	vec2 delta = v_tex_uv - u_center;
	float radius = length(delta);
	float theta = atan(delta.y, delta.x);

	delta.x = u_r0 * cos(theta);
	delta.y = u_r0 * sin(theta);
	delta += u_center;

	vec4 color1 = texture2D(s_texture, delta);
	float fraction = smoothstep(0.0, 1.0, radius);
	vec4 result = mix(color0, color1, fraction);		// TODO strength

	gl_FragColor = result;
}
