uniform sampler2D s_texture;
uniform vec2 u_center;
uniform float u_r0;
varying vec2 v_tex_uv;

void main()
{
	vec4 color0 = texture2D(s_texture, v_tex_uv);

	vec2 delta = v_tex_uv - u_center;
	float radius = length(delta);
	float theta = atan(delta.y, delta.x);

	if (radius > u_r0)		// tunnel light
		radius = u_r0;

	delta.x = radius * cos(theta);
	delta.y = radius * sin(theta);
	delta += u_center;

	vec4 color1 = texture2D(s_texture, delta);
	vec4 result = mix(color0, color1, 1.0);		// TODO strength

	gl_FragColor = result;
}