uniform sampler2D s_samples;
uniform float u_opacity;
uniform vec2 u_p0;
uniform float u_r1;		// actaully distance from p0 to p1
uniform float u_sin_t;
uniform float u_cos_t;
varying vec2 v_src_uv;

void main()
{
	float x = v_src_uv.x - u_p0.x;
	float y = v_src_uv.y - u_p0.y;
	y = x * u_sin_t + y * u_cos_t;
	float value = clamp(y / u_r1, 0.0, 1.0);

	vec4 color = texture2D(s_samples, vec2(value, 0.5));
	color.a *= u_opacity;
	gl_FragColor = color;
}
