uniform sampler2D s_samples;
uniform float u_opacity;
uniform float u_r0;
uniform float u_r1;			// actually r1 - r0
uniform float u_rr;			// reciprocal of roundness
uniform float u_sin_t;
uniform float u_cos_t;
varying vec2 v_src_uv;

void main()
{
	vec2 p;
	p.x = v_src_uv.x *  u_cos_t + v_src_uv.y * u_sin_t;
	p.y = v_src_uv.x * -u_sin_t + v_src_uv.y * u_cos_t;
	p.y *= u_rr;			// scale y for roundness
	float d = length(p) - u_r0;
	d /= u_r1;
	if (d > 1.0)
		discard;

	d = clamp(d, 0.0, 1.0);

	vec4 color = texture2D(s_samples, vec2(d, 0.5));
	color.a *= u_opacity;
	gl_FragColor = color;
}
