uniform sampler2D s_samples;
uniform float u_opacity;
uniform vec2 u_p0;
uniform float u_r0;
uniform float u_r1;			// actually r1 - r0
varying vec2 v_src_uv;

float calc(vec2 src_uv, vec2 p0, float r0, float r1)
{
	src_uv.x -= p0.x;
	src_uv.y -= p0.y;
	float d = length(src_uv) - r0;
	d /= r1;
	return clamp(d, 0.0, 1.0);
}

void main()
{
	float value = calc(v_src_uv, u_p0, u_r0, u_r1);

	vec4 color = texture2D(s_samples, vec2(value, 0.5));
	color.a *= u_opacity;
	gl_FragColor = color;
}
