uniform sampler2D s_mask;
varying highp vec2 v_tex_uv;
uniform lowp vec4 u_color_0;
uniform lowp vec4 u_color_1;

void main()
{
	lowp vec4 maskColor;
	
	mediump float alpha = texture2D(s_mask, v_tex_uv).a;
	if (alpha < 0.5)
	{
		alpha = 1.0 - (alpha * 2.0);
		maskColor = vec4(u_color_0.r, u_color_0.g, u_color_0.b, u_color_0.a * alpha);
	}
	else
	{
		alpha = (alpha - 0.5) * 2.0;
		maskColor = vec4(u_color_1.r, u_color_1.g, u_color_1.b, u_color_1.a * alpha);
	}
	
	gl_FragColor = maskColor;					// note: requires blending
}
