DESTINATION_HEADER

uniform sampler2D s_mask;
uniform float u_opacity;
varying vec2 v_mask_uv;


void main()
{
#if 0
    mat3 m = mat3		// RGB to YIQ
    (
     vec3(0.299, 0.595716, 0.211456),
     vec3(0.587, -0.274453, -0.522591),
     vec3(0.114, -0.321263, 0.311135)
     );
    mat3 m1 = mat3		// YIQ to RGB
    (
     vec3(1.0, 1.0, 1.0),
     vec3(0.9563, -0.2721, -1.1070),
     vec3(0.6210, -0.6474, 1.7046)
     );
#endif
    
    
#if 0
    mat3 m = mat3		// RGB to YUV (BT.709)
    (
     vec3(0.2126, -0.09991, 0.615),
     vec3(0.7152, -0.33609, -0.55861),
     vec3(0.0722, 0.436, -0.05639)
     );
    mat3 m1 = mat3		// YUV to RGB
    (
     vec3(1.0,      1.0,      1.0),
     vec3(0.0,     -0.21842,  2.12798),
     vec3(1.28033, -0.38059,  0.0)
     );
#endif

#if 1
    mat3 m = mat3										// sRGB to Ycc
    (												    // following CR's derivation from RGB -> Y
     vec3(0.2126729 ,  0.5       , -0.05730415),
     vec3(0.7151522 , -0.4541646 , -0.19269587),
     vec3(0.072175  , -0.01944736,  0.25)
     );
    mat3 m1 = mat3										// Ycc to sRGB
    (												    // following CR's derivation from RGB -> Y
     vec3(0.95844787,  1.01235669,  1.),
     vec3(1.5746542 , -0.46827273,  0.),
     vec3(-0.15421241, -0.32869406,  3.7113)
     );
#endif


    vec4 dst = DESTINATION_FETCH;
    vec3 yiq = m * dst.rgb;
	
    float srcValue = texture2D(s_mask, v_mask_uv).a;
	yiq.yz *= srcValue * 2.0;			// scale chroma
	
    vec3 rgb = m1 * yiq;
    vec4 value = vec4(rgb.r, rgb.g, rgb.b, dst.a);
    
    gl_FragColor = mix(dst, value, u_opacity * dst.a);
}
