#version 300 es
in vec4 position;
in vec2 texcoord; // PSX MOD: changed from vec3 to vec2 to take existing values as input

uniform highp mat4 uMVPMatrix;    // PSX MOD: added param to accept existing rendering parameters
uniform highp mat4 uTexTransformRotate; // PSX MOD: added param to control rotation of texture, TODO: can we change to a single mat for all?

out highp vec2 vTextureCoord;

void main() {
    gl_Position = uMVPMatrix * position;
    vec4 transCoord = uTexTransformRotate * vec4(texcoord - 0.5, 0.0, 1.0);
    vTextureCoord = transCoord.xy + 0.5;
}

// Modified from: https://git.corp.adobe.com/lightroom/VideoFoundation/blob/main/Android/VFPlayerLib/src/main/assets/video-foundation/shaders/vfplayerlib_simple_vertex.glsl
